//+------------------------------------------------------------------+
//|                    AmazingEA.mq4 Version 4.3.0 By Alan Prothero  |
//|               See "AmazingEA Change Log.txt" for Update History  |
//+------------------------------------------------------------------+
#property copyright "Alan Prothero"

// Please check the following Thread on Forex Factory for News and Updates:-
// http://www.forexfactory.com/showthread.php?t=6854

extern int PointsAway=80; // Points Away, number of points above and below the current price where the orders will be placed
extern int PointsGap=2000; // Points Gap, number of points above and below the current price where the orders are initially opened before moving to PointsAway level
extern int ModifyGap=10; // Modify Gap, number of points above and below the current price that causes a pending order modification to occur
extern int TP=1000; // Take Profit, exact amount of points from open price (set to 0 to disable)
extern int SL=100; // Stop Loss, hard stop from open price (set to 0 to disable)
extern int NYear=0;  // News Year (set to 0 to enable EA every day)
extern int NMonth=0;  // News Month (set to 0 to enable EA every day)
extern int NDay=0;  // News Day (set to 0 to enable EA every day)
extern int NHour=0; // News Hour
extern int NMin=0;  // News Minute
extern int NSec=0;  // News Second
extern int CTCBN=0; // Numbers of Candles To Check Before News, for determining highs & lows (when it is 1 it checks the current candle) (set to 0 to disable)
extern int SecBPO=20; // Seconds Before Pending Orders, number of seconds before news when pending orders will be placed
extern int SecBAO=5; // Seconds Before Adjacent Orders, number of seconds before news when orders will be brought close to current price
extern int SecBMO=0; // Seconds Before Modifying Orders, number of seconds before news when orders will stop being modified
extern int STWAN=5; // Seconds To Wait After News, number of seconds after news to wait before deleting pending orders
extern bool OCO=true; // Order Cancel Other, will cancel the other pending order if one of them is activated but only after news time
extern int BEPoints=0; // Break Even Points, number of points in profit before the stop loss is moved to Break Even + BEOffset (set to 0 to disable)
extern int BEOffset=0; // Break Even Offset, number of points to move beyond Break Even (allows to cover Broker Commissions etc.) (set to 0 to disable)
extern int TrailPoints=0; // Trailing Stop, number of points to a trailing stop (set to 0 to disable)
extern int TrailOffset=0; // Trailing Stop Offset, number of points profit required before starting to trail stops (set to 0 to disable)
extern bool TrailImmediate=false; // Trailing Stop active when trade opened, EA will trail immediately when true (set to false to start trailing when in profit)
extern bool MM=false; // Money Management, if true uses Risk Percentage, if false uses Lot Size and Stop Loss distance
extern double RiskPercent=2.5; // Risk Percentage, percent amount of account to risk when Money Management set to true, overrides Lot Size
extern double Lots=0.1; // Lot Size, number of lots to trade when Money Management set to false
extern int MaxSpread=60; // Maximum Spread, Cancels Pending Orders if Spread exceeds this setting (set to 0 to disable)
extern bool AddSpreadToSL=true; // Adds the Spread to the Stop Loss, if true you can set lower SL
extern bool SlipCheck=false; // Checks for Slippage and Stop Loss Reset, set to false to replicate 'old' EA
extern int MaxSlippage=200; // Maximum Slippage, if the slippage (open price vs. requested price) exceeds this setting then set the minimum stop loss on the trade (set to 0 to disable).
extern bool AllowBuys=true; // Set to false to switch off Buy Trades, default setting is true
extern bool AllowSells=true; // Set to false to switch off Sell Trades, default setting is true
extern bool UseBrokerTime=true; // UseBrokerTime=true is how the EA used to work, UseBrokerTime=false uses the Local PC Time instead
extern string TradeLog = "AmazingEA"; // Log is created in experts/files sub-directory with this name followed by the CurrencySymbol followed by .log as an extension
double h,l,ho,lo,hso,lso,htp,ltp,sp;
int Magic;
string filename;
string TradeComment;
// bool OrdersTriggered=false; // Commented out for now - can be implemented in the future

double LotsOptimized()
{
	double lot=Lots;
	//---- select lot size
	if (MM) { // if using Money Management
		if (SL!=0) { // if SL is set, take into account Stop Loss Distance
			if (AddSpreadToSL) { // if AddSpreadToSL is true, add in MaxSpread
				lot=NormalizeDouble(MathFloor(AccountFreeMargin()*RiskPercent/100)/(SL+MaxSpread),1);
			}
			else // if AddSpreadToSL is false, just use SL
			{
				lot=NormalizeDouble(MathFloor(AccountFreeMargin()*RiskPercent/100)/(SL),1);
			}
		}
		else // if SL is 0, don't take into account Stop Loss Distance
		{
			lot=NormalizeDouble(MathFloor(AccountFreeMargin()*RiskPercent/100)/100,1);
		}
	}
	return(lot);
} 

string AddLeadingZero(int number, int digits)
{
	// add leading zeros that the resulting string has 'digits' length.
	string result;
	result = DoubleToStr(number, 0);
	while(StringLen(result)<digits) result = "0"+result;
	return(result);
}

int CheckOrdersCondition()
{
	int result=0;
	for (int i=OrdersTotal()-1; i>=0; i--) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderType()==OP_BUY && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
				result=result+1000; 
			}
			if (OrderType()==OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
				result=result+100; 
			}
			if (OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
				result=result+10;
			}
			if (OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
				result=result+1; 
			}
		}
	}
	return(result); // 0 means we have no trades
}

// OrdersCondition Result Pattern
//    1    1    1    1
//    b    s    bs   ss
//

void OpenBuyStop()
{
	int ticket,tries;
	tries = 0;
	if (!GlobalVariableCheck("InTrade")) {
		while (tries<3)
		{
			GlobalVariableSet("InTrade", CurTime());  // set lock indicator
			ticket = OrderSend(Symbol(),OP_BUYSTOP,LotsOptimized(),ho,1,hso,htp,TradeComment,Magic,0,Green);
			Write("OpenBuyStop, OrderSend Executed, @ "+ho+" SL @ "+hso+" TP @ "+htp+" ticket="+ticket);
			GlobalVariableDel("InTrade");   // clear lock indicator
			if (ticket<=0) {
				Write("Error Occurred : "+ErrorDescription(GetLastError()));
				tries++;
			} else tries = 3;
		}
	}
}

void OpenSellStop()
{
	int ticket,tries;
	tries = 0;
	if (!GlobalVariableCheck("InTrade")) {
		while (tries<3)
		{
			GlobalVariableSet("InTrade", CurTime());  // set lock indicator
			ticket = OrderSend(Symbol(),OP_SELLSTOP,LotsOptimized(),lo,1,lso,ltp,TradeComment,Magic,0,Red);
			Write("OpenSellStop, OrderSend Executed, @ "+lo+" SL @ "+lso+" TP @ "+ltp+" ticket="+ticket);
			GlobalVariableDel("InTrade");   // clear lock indicator
			if (ticket<=0) {
				Write("Error Occurred : "+ErrorDescription(GetLastError()));
				tries++;
			} else tries = 3;
		}
	}
}

void DoModify()
{
	double hbp,lbp,hsp,lsp;
	for (int i=OrdersTotal()-1; i>=0; i--) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderType()==OP_BUYSTOP) {
				hbp=OrderOpenPrice()+(ModifyGap*Point);
				lbp=OrderOpenPrice()-(ModifyGap*Point);
				if (NormalizeDouble(ho,Digits)>NormalizeDouble(hbp,Digits) || NormalizeDouble(ho,Digits)<NormalizeDouble(lbp,Digits)) {
					Write("Buy Stop was @ "+DoubleToStr(OrderOpenPrice(),Digits)+", changed to "+DoubleToStr(ho,Digits));
					if ( ! OrderModify(OrderTicket(),ho,hso,htp,0,Green)) {
						Write("Error Occurred : "+ErrorDescription(GetLastError()));
					}
				}
			}
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderType()==OP_SELLSTOP) {
				hsp=OrderOpenPrice()+(ModifyGap*Point);
				lsp=OrderOpenPrice()-(ModifyGap*Point);
				if (NormalizeDouble(lo,Digits)>NormalizeDouble(hsp,Digits) || NormalizeDouble(lo,Digits)<NormalizeDouble(lsp,Digits)) {
					Write("Sell Stop was @ "+DoubleToStr(OrderOpenPrice(),Digits)+", changed to "+DoubleToStr(lo,Digits));
					if ( ! OrderModify(OrderTicket(),lo,lso,ltp,0,Red)) {
						Write("Error Occurred : "+ErrorDescription(GetLastError()));
					}
				}
			}
		}
	}
}

void DoSlip()
{
	int MinStopLevel=MarketInfo(Symbol(),MODE_STOPLEVEL); // Min. distance for Stops
	int slippage;
	double osl,sl,be,otp,tp;
	for (int i=OrdersTotal()-1; i>=0; i--) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if ((OrderSymbol()==Symbol()) && (OrderMagicNumber()==Magic)) { // only look if mygrid and symbol...
				otp=OrderTakeProfit();
				osl=OrderStopLoss();
				if (OrderType()==OP_BUY) {
					be=OrderOpenPrice()+((BEPoints+BEOffset)*Point);
					tp=OrderOpenPrice()+(TP*Point);
					slippage=NormalizeDouble((tp - otp)/Point,0); // slippage is how far Take Profit is out by
					if (MaxSlippage!=0 && slippage>MaxSlippage) // if slippage exceeds maxslippage
					{
						if (AddSpreadToSL) { // set MinStop
							sl=OrderOpenPrice()-sp-(MinStopLevel*Point);
						}
						else {
							sl=OrderOpenPrice()-(MinStopLevel*Point);
						}
						Write("Slippage of Buy Order was "+slippage+", exceeded MaxSlippage of "+MaxSlippage+", setting MinStop to "+DoubleToStr(sl,Digits));
					}
					else // if slippage does not exceed maxslippage
					{
						if (slippage>0) { //output slippage to log
							Write("Slippage of Buy Order was "+slippage);
						}
						if (AddSpreadToSL) { // set normal stop
							sl=OrderOpenPrice()-sp-(SL*Point);
						}
						else {
							sl=OrderOpenPrice()-(SL*Point);
						}
					}
					if (Bid>tp)
					// if bid higher than buy take profit level, close
					{
						Write("Take Profit of Buy Order Hit at "+DoubleToStr(tp,Digits)+", Closing at "+DoubleToStr(Bid,Digits));
						if ( ! OrderClose(OrderTicket(),OrderLots(),Bid,0,Green)) {
							Write("Error Occurred : "+ErrorDescription(GetLastError()));
						}
					}
					if (BEPoints==0 || Bid<be) {
						if (osl<sl) 
						// is bid lower than break-even (open + BE) and 
						// is stop loss lower than where it should be
						{
							if (Bid<sl)
							// if bid lower than buy stop level, close 
							{
								Write("Stop Loss of Buy Order Hit at "+DoubleToStr(sl,Digits)+", Closing at "+DoubleToStr(Bid,Digits));
								if ( ! OrderClose(OrderTicket(),OrderLots(),Bid,0,Green)) {
									Write("Error Occurred : "+ErrorDescription(GetLastError()));
								}
							}
							if (Bid>sl) 
							// if bid higher than sl, reset stop loss and take profit
							{
								Write("Stop Loss of Buy Order Reset to "+DoubleToStr(sl,Digits)+", Take Profit of Buy Order Reset to "+DoubleToStr(tp,Digits)+" at "+DoubleToStr(Bid,Digits));
								if ( ! OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,Green)) {
									Write("Error Occurred : "+ErrorDescription(GetLastError()));
								}
							}
						}
					}
				}
				if (OrderType()==OP_SELL) {
					be=OrderOpenPrice()-((BEPoints+BEOffset)*Point);
					tp=OrderOpenPrice()-(TP*Point);
					slippage=NormalizeDouble((otp-tp)/Point,0); // slippage is how far Take Profit is out by
					if (MaxSlippage!=0 && slippage>MaxSlippage) // if slippage exceeds maxslippage
					{
						if (AddSpreadToSL) { // set MinStop
							sl=OrderOpenPrice()+sp+ (MinStopLevel*Point);
						}
						else {
							sl=OrderOpenPrice()+(MinStopLevel*Point);
						}
						Write("Slippage of Sell Order was "+slippage+", exceeded MaxSlippage of "+MaxSlippage+", setting MinStop to "+DoubleToStr(sl,Digits));
					}
					else // if slippage does not exceed maxslippage
					{
						if (slippage>0) { //output slippage to log
							Write("Slippage of Sell Order was "+slippage);
						}
						if (AddSpreadToSL) { // set normal stop
							sl=OrderOpenPrice()+sp+(SL*Point);
						}
						else {
							sl=OrderOpenPrice()+(SL*Point);
						}
					}
					if (Ask<tp) 
					// if ask lower than sell take profit level, close
					{
						Write("Take Profit of Sell Order Hit at "+DoubleToStr(tp,Digits)+", Closing at "+DoubleToStr(Ask,Digits));
						if ( ! OrderClose(OrderTicket(),OrderLots(),Ask,0,Red)) {
							Write("Error Occurred : "+ErrorDescription(GetLastError()));
						}
					}
					if (BEPoints==0 || Ask>be) {
						if (osl>sl)
						// is ask higher than break-even (open - BE) and 
						// is stop loss higher than where it should be
						{
							if (Ask>sl) 
							// if ask higher than sell stop level, close
							{
								Write("Stop Loss of Sell Order Hit at "+DoubleToStr(sl,Digits)+", Closing at "+DoubleToStr(Ask,Digits));
								if ( ! OrderClose(OrderTicket(),OrderLots(),Ask,0,Red)) {
									Write("Error Occurred : "+ErrorDescription(GetLastError()));
								}
							}
							if (Ask<sl) 
							// if ask lower than sl reset stop loss and take profit
							{ 
								Write("Stop Loss of Sell Order Reset to "+DoubleToStr(sl,Digits)+", Take Profit of Sell Order Reset to "+DoubleToStr(tp,Digits)+" at "+DoubleToStr(Bid,Digits));
								if ( ! OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,Red)) {
									Write("Error Occurred : "+ErrorDescription(GetLastError()));
								}
							}
						}
					}
				}
			}
		}
	}
}

void DoSL()
{
	double osl,be,sl;
	for (int i=OrdersTotal()-1; i>=0; i--) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
			if ((OrderSymbol()==Symbol()) && (OrderMagicNumber()==Magic)) { // only look if mygrid and symbol...
				osl=OrderStopLoss();
				if (OrderType()==OP_BUY) {
					be=OrderOpenPrice()+((BEPoints+BEOffset)*Point);
					if (AddSpreadToSL)
					{
						sl=OrderOpenPrice()-sp-(SL*Point);
					}
					else
					{
						sl=OrderOpenPrice()-(SL*Point);
					}
					if (BEPoints==0 || Bid<be){
						if (osl<sl) 
						// is bid lower than break-even (open + BE) and 
						// is stop loss lower than where it should be
						{
							if (Bid<sl)
							// if bid lower than buy stop level, close 
							{
								Write("Stop Loss of Buy Order Hit at "+DoubleToStr(sl,Digits)+", Closing at "+DoubleToStr(Bid,Digits));
								if ( ! OrderClose(OrderTicket(),OrderLots(),Bid,0,Green)) {
									Write("Error Occurred : "+ErrorDescription(GetLastError()));
								}
							}
							if (Bid>sl) 
							// if bid higher than sl, reset stop loss set to open minus stop loss
							{
								Write("Stop Loss of Buy Order Reset to "+DoubleToStr(sl,Digits)+", at "+DoubleToStr(Bid,Digits));
								if ( ! OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Green)) {
									Write("Error Occurred : "+ErrorDescription(GetLastError()));
								}
							}
						}
					}
				}
				if (OrderType()==OP_SELL) {
					be=OrderOpenPrice()-((BEPoints+BEOffset)*Point);
					if (AddSpreadToSL)
					{
						sl=OrderOpenPrice()+sp+(SL*Point);
					}
					else
					{
						sl=OrderOpenPrice()+(SL*Point);
					}
					if (BEPoints==0 || Ask>be) {
						if (osl>sl)
						// is ask higher than break-even (open - BE) and 
						// is stop loss higher than where it should be
						{
							if (Ask>sl) 
							// if ask higher than sell stop level, close
							{
								Write("Stop Loss of Sell Order Hit at "+DoubleToStr(sl,Digits)+", Closing at "+DoubleToStr(Ask,Digits));
								if ( ! OrderClose(OrderTicket(),OrderLots(),Ask,0,Red)) {
									Write("Error Occurred : "+ErrorDescription(GetLastError()));
								}
							}
							if (Ask<sl) 
							// if ask lower than sl reset stop loss set to open plus stop loss
							{ 
								Write("Stop Loss of Sell Order Reset to "+DoubleToStr(sl,Digits)+", at "+DoubleToStr(Ask,Digits));
								if ( ! OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Red)) {
									Write("Error Occurred : "+ErrorDescription(GetLastError()));
								}
							}
						}
					}
				}
			}
		}
	}
}

void DoTP()
{
	double otp,tp;
	for (int i=OrdersTotal()-1; i>=0; i--) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if ((OrderSymbol()==Symbol()) && (OrderMagicNumber()==Magic)) { // only look if mygrid and symbol...
				otp=OrderTakeProfit();
				if (OrderType()==OP_BUY) {
					tp=OrderOpenPrice()+(TP*Point);
					if (otp<tp || otp>tp) 
					// is take profit lower than where it should be
					{
						if (Bid>tp)
						// if bid higher than buy take profit level, close
						{
							Write("Take Profit of Buy Order Hit at "+DoubleToStr(tp,Digits)+", Closing at "+DoubleToStr(Bid,Digits));
							if ( ! OrderClose(OrderTicket(),OrderLots(),Bid,0,Green)) {
								Write("Error Occurred : "+ErrorDescription(GetLastError()));
							}
						}
						if (Bid<tp) 
						// if bid lower than tp, reset take profit to open plus take profit setting
						{
							Write("Take Profit of Buy Order Reset to "+DoubleToStr(tp,Digits)+", at "+DoubleToStr(Bid,Digits));
							if ( ! OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0,Green)) {
								Write("Error Occurred : "+ErrorDescription(GetLastError()));
							}
						}
					}
				}
				if (OrderType()==OP_SELL) {
					tp=OrderOpenPrice() - (TP * Point);
					if (otp<tp || otp>tp)
					// is stop loss higher than where it should be
					{
						if (Ask<tp) 
						// if ask lower than sell take profit level, close
						{
							Write("Take Profit of Sell Order Hit at "+DoubleToStr(tp,Digits)+", Closing at "+DoubleToStr(Ask,Digits));
							if ( ! OrderClose(OrderTicket(),OrderLots(),Ask,0,Red)) {
								Write("Error Occurred : "+ErrorDescription(GetLastError()));
							}
						}
						if (Ask>tp) 
						// if ask lower than sl reset stop loss set to open plus stop loss
						{ 
							Write("Take Profit of Sell Order Reset to "+DoubleToStr(tp,Digits)+", at "+DoubleToStr(Ask,Digits));
							if ( ! OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0,Red)) {
								Write("Error Occurred : "+ErrorDescription(GetLastError()));
							}
						}
					}
				}
			}
		}
	}
}

void DoBE()
{
	double osl,be,of;
	for (int i=OrdersTotal()-1; i>=0; i--) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) { // only look if mygrid and symbol...
				osl=OrderStopLoss();
				if (OrderType()==OP_BUY) {
					be=OrderOpenPrice()+((BEPoints+BEOffset)*Point);
					of=OrderOpenPrice()+(BEOffset*Point);
					if (NormalizeDouble(osl,Digits)<NormalizeDouble(of,Digits) || osl==0)
					// is stop loss lower than open plus BE offset
					{
						if (Bid>be) 
						// is bid higher than break-even (open + BE)
						{
							Write("Break Even of Buy Order set to "+DoubleToStr(of,Digits)+" at "+DoubleToStr(Bid,Digits));
							if ( ! OrderModify(OrderTicket(),OrderOpenPrice(),of,OrderTakeProfit(),0,Green)) {
								Write("Error Occurred : "+ErrorDescription(GetLastError()));
							}
						}
						if (Bid<osl && osl!=0)
						// if bid lower than buy stop level, close 
						{
							Write("Stop Loss of Buy Order Hit at "+DoubleToStr(osl,Digits)+", Closing at "+DoubleToStr(Bid,Digits));
							if ( ! OrderClose(OrderTicket(),OrderLots(),Bid,0,Green)) {
								Write("Error Occurred : "+ErrorDescription(GetLastError()));
							}
						}
					}
				}
				if (OrderType()==OP_SELL) {
					be=OrderOpenPrice()-((BEPoints+BEOffset)*Point);
					of=OrderOpenPrice()-(BEOffset*Point);
					if (NormalizeDouble(osl,Digits)>NormalizeDouble(of,Digits) || osl==0)
					// is stop loss higher than open minus BE offset
					{
						if (Ask<be)
						// is ask lower than break-even (open - BE)
						{
							Write("Break Even of Sell Order set to "+DoubleToStr(of,Digits)+" at "+DoubleToStr(Ask,Digits));
							if ( ! OrderModify(OrderTicket(),OrderOpenPrice(),of,OrderTakeProfit(),0,Red)) {
								Write("Error Occurred : "+ErrorDescription(GetLastError()));
							}
						}
						if (Ask>osl && osl!=0) 
						// if ask higher than sell stop level, close
						{
							Write("Stop Loss of Sell Order Hit at "+DoubleToStr(osl,Digits)+", Closing at "+DoubleToStr(Ask,Digits));
							if ( ! OrderClose(OrderTicket(),OrderLots(),Ask,0,Red)) {
								Write("Error Occurred : "+ErrorDescription(GetLastError()));
							}
						}
					}
				}
			}
		}
	}
}

void DoTrail()
{
	double osl,to,tl;
	for (int i=OrdersTotal()-1; i>=0; i--) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) { // only look if mygrid and symbol...
				osl=OrderStopLoss();
				if (OrderType()==OP_BUY) {
					to=OrderOpenPrice()+((TrailPoints+TrailOffset)*Point);
					tl=Bid-(TrailPoints*Point);
					if ((!TrailImmediate && Bid>to) || TrailImmediate) 
					// is bid higher than open plus trail and offset setting or is TrailImmediate=true
					{
						if (NormalizeDouble(osl,Digits)<NormalizeDouble(tl,Digits) || osl==0)
						// is stop loss less than bid minus the trail setting
						{
							Write("Trailing Stop of Buy Order set to "+DoubleToStr(tl,Digits)+" at "+DoubleToStr(Bid,Digits));
							if ( ! OrderModify(OrderTicket(),OrderOpenPrice(),tl,OrderTakeProfit(),0,Green)) {
								Write("Error Occurred : "+ErrorDescription(GetLastError()));
							}
						}
					}
					if (Bid<osl && osl!=0)
					// if bid lower than buy stop level, close 
					{
						Write("Stop Loss of Buy Order Hit at "+DoubleToStr(osl,Digits)+", Closing at "+DoubleToStr(Bid,Digits));
						if ( ! OrderClose(OrderTicket(),OrderLots(),Bid,0,Green)) {
							Write("Error Occurred : "+ErrorDescription(GetLastError()));
						}
					}
				}
				if (OrderType()==OP_SELL) {
					to=OrderOpenPrice()-((TrailPoints+TrailOffset)*Point);
					tl=Ask+(TrailPoints*Point);
					if ((!TrailImmediate && Ask<to) || TrailImmediate) 
					// is ask lower than open minus trail and offset setting or is TrailImmediate=true
					{
						if (NormalizeDouble(osl,Digits)>NormalizeDouble(tl,Digits) || osl==0)
						// is stop loss higher than ask plus the trail setting
						{
							Write("Trailing Stop of Sell Order set to "+DoubleToStr(tl,Digits)+" at "+DoubleToStr(Ask,Digits));
							if ( ! OrderModify(OrderTicket(),OrderOpenPrice(),tl,OrderTakeProfit(),0,Red)) {
								Write("Error Occurred : "+ErrorDescription(GetLastError()));
							}
						}
					}
					if (Ask>osl && osl!=0) 
					// if ask higher than sell stop level, close
					{
						Write("Stop Loss of Sell Order Hit at "+DoubleToStr(osl,Digits)+", Closing at "+DoubleToStr(Ask,Digits));
						if ( ! OrderClose(OrderTicket(),OrderLots(),Ask,0,Red)) {
							Write("Error Occurred : "+ErrorDescription(GetLastError()));
						}
					}
				}
			}
		}
	}
}

void DeleteBuyStop()
{
	for (int i=OrdersTotal()-1; i>=0; i--) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderType()==OP_BUYSTOP) {
				if ( ! OrderDelete(OrderTicket())) {
					Write("Error Occurred : "+ErrorDescription(GetLastError()));
				} 
				else 
				{
					Write("DeleteBuyStop, OrderDelete Executed");
				}
			}
		}
	}
}

void DeleteSellStop()
{
	for (int i=OrdersTotal()-1; i>=0; i--) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderType()==OP_SELLSTOP) {
				if ( ! OrderDelete(OrderTicket())) {
					Write("Error Occurred : "+ErrorDescription(GetLastError()));
				} 
				else 
				{
					Write("DeleteSellStop, OrderDelete Executed");
				}
			}
		}
	}
}

void OrdersDeleteAll()
{
	DeleteBuyStop();
	DeleteSellStop();
}

int Write(string str)
{
	int handle;
	handle = FileOpen(filename,FILE_READ|FILE_WRITE|FILE_CSV,"/t");
	FileSeek(handle, 0, SEEK_END);      
	FileWrite(handle, TimeToStr(CurTime(),TIME_DATE|TIME_SECONDS) + " " + str);
	FileClose(handle);
	return(0);
}

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
	//ObjectsDeleteAll();
	return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
	Comment("");
	Write("Amazing EA shut down");
	OrdersDeleteAll();
	return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
	Magic=(NHour*10000)+(NMin*100)+NSec;

	int i;
	int secofday,secofnews;
	string brokertime;
	int OrdersCondition=CheckOrdersCondition();
	int MinStopLevel=MarketInfo(Symbol(),MODE_STOPLEVEL); // Min. distance for Stops
	filename=TradeLog + "-" + Symbol() + ".log";

	if (ModifyGap>20) { 
		ModifyGap = 20 ; 
	}

	if (SL!=0 && SL<MinStopLevel) { 
		SL = MinStopLevel ; 
	}

	if (TP!=0 && TP<MinStopLevel) { 
		TP = MinStopLevel ; 
	}

	if (TrailPoints!=0 && TrailPoints<MinStopLevel) { 
		TrailPoints = MinStopLevel ; 
	}

	if (BEPoints!=0 && BEPoints<MinStopLevel) { 
		BEPoints = MinStopLevel ; 
	}

	if (OrdersCondition>11) { // we have open trades, amending stops
		//		OrdersTriggered=true; // Set switch to Triggered to prevent new orders being created
		if (SlipCheck && SL!=0 && TP!=0) DoSlip(); // SL and TP both set, work out slippage
		if (SlipCheck && SL!=0 && TP==0) DoSL(); // SL set so can reset SL, TP not set so can't workout slippage
		if (SlipCheck && SL==0 && TP!=0) DoTP(); // TP set but no SL, no point working out slippage
		if (TrailPoints!=0) DoTrail(); // perform trailing stop processing
		if (BEPoints!=0) DoBE(); // perform break even processing
	}

	if (UseBrokerTime) {
		secofday=Hour()*3600+Minute()*60+Seconds();
		brokertime=TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS); // BrokerTime is shown in the EA Comment.
	}
	else
	{
		int DYear=TimeYear(TimeLocal());
		int DMonth=TimeMonth(TimeLocal());
		int DDay=TimeDay(TimeLocal());
		int DHour=TimeHour(TimeLocal());
		int DMinute=TimeMinute(TimeLocal());
		int DSeconds=TimeSeconds(TimeLocal());
		secofday=DHour*3600+DMinute*60+DSeconds;
		brokertime=TimeToStr(TimeLocal(),TIME_DATE|TIME_SECONDS); // BrokerTime is shown in the EA Comment.
	}

	secofnews=NHour*3600+NMin*60+NSec;

	if (SecBPO!=SecBAO && PointsAway<PointsGap) {
		if (secofday<secofnews && secofday>(secofnews-SecBPO) && secofday<(secofnews-SecBAO)) 
		{ // if before news but after (news minus BPO) and before (news minus BAO)
			{
				PointsAway=PointsAway+PointsGap;
			}
		}
	}

	if (SecBPO!=SecBAO && PointsAway>=PointsGap) {
		if (secofday<secofnews && secofday>(secofnews-SecBPO) && secofday>=(secofnews-SecBAO)) 
		{ // if before news but after (news minus BPO) and after (news minus BAO)
			{
				PointsAway=PointsAway-PointsGap;
			}
		}
	}

	if (CTCBN==0) 
	{
		h=Bid;
		l=Bid;
	}
	else
	{
		h=iHigh(NULL,0,0);
		l=iLow(NULL,0,0);
		for (i=1;i<=CTCBN;i++) if (iHigh(NULL,0,i-1)>h) h=iHigh(NULL,0,i-1);
		for (i=1;i<=CTCBN;i++) if (iLow(NULL,0,i-1)<l) l=iLow(NULL,0,i-1);
	}

	sp=Ask-Bid;

	int spread=NormalizeDouble(sp/Point,0);
	
	ho=h+sp+(PointsAway*Point); 
	if (ho < Ask+(MinStopLevel*Point)) ho=Ask+(MinStopLevel*Point); //Ensure orders are MinStopLevel away but only if necessary
	lo=l-(PointsAway*Point);
	if (lo > Bid-(MinStopLevel*Point)) lo=Bid-(MinStopLevel*Point); //Ensure orders are MinStopLevel away but only if necessary

	if (SL==0)
	{
		hso = 0;
		lso = 0;
	}
	else if (AddSpreadToSL)
	{
		hso=ho-sp-(SL*Point); //Bid+(PointsAway*Point)-(SL*Point); //hso=Ask+(PipsAway-SL)*Point; //hso=h+sp;
		lso=lo+sp+(SL*Point); //Ask-(PointsAway*Point)+(SL*Point); //lso=Bid-(PipsAway-SL)*Point; //lso=l;
	}
	else
	{
		hso=ho-(SL*Point); //Ask+(PointsAway*Point)-(SL*Point)
		lso=lo+(SL*Point); //Bid-(PointsAway*Point)+(SL*Point)
	}

	if (TP==0)
	{
		htp = 0;
		ltp = 0;
	}
	else
	{ 
		htp=ho+(TP*Point);
		ltp=lo-(TP*Point);
	}

	string title="Amazing Forex System Expert Advisor v 4.3.0 By Alan Prothero";
	string newstime=StringConcatenate(AddLeadingZero(NYear,4),".",AddLeadingZero(NMonth,2),".",AddLeadingZero(NDay,2)," ",TimeToStr(secofnews,TIME_SECONDS));
	string timetitle=StringConcatenate("System Time : ", brokertime, "\nNews Time    : ", newstime);
	string DisplayOCO="False";
	if (OCO) DisplayOCO="True";
	string DisplayMM="False";
	if (MM) DisplayMM="True";
	string DisplayAddSpreadToSL="False";
	if (AddSpreadToSL) DisplayAddSpreadToSL="True";
	string DisplaySlipCheck="False";
	if (SlipCheck) DisplaySlipCheck="True";
	string DisplayTrailImmediate="False";
	if (TrailImmediate) DisplayTrailImmediate="True";
	//	string DisplayOrdersTriggered="False";
	//	if (OrdersTriggered) DisplayOrdersTriggered="True";
	string DisplayAllowBuys="False";
	if (AllowBuys) DisplayAllowBuys="True";
	string DisplayAllowSells="False";
	if (AllowSells) DisplayAllowSells="True";
	string DisplayUseBrokerTime="False";
	if (UseBrokerTime) DisplayUseBrokerTime="True";
	string Comment1=StringConcatenate("High @ ",DoubleToStr(h,Digits)," BuyOrder @ ",DoubleToStr(ho,Digits)," StopLoss @ ",DoubleToStr(hso,Digits)," TakeProfit @ ",DoubleToStr(htp,Digits));
	string Comment2=StringConcatenate("Low  @ ",DoubleToStr(l,Digits)," SellOrder @ ",DoubleToStr(lo,Digits)," StopLoss @ ",DoubleToStr(lso,Digits)," TakeProfit @ ",DoubleToStr(ltp,Digits));
	string Comment3=StringConcatenate("PointsAway : ",PointsAway," | PointsGap : ",PointsGap," | ModifyGap : ",ModifyGap);
	string Comment4=StringConcatenate("BEOffset : ",BEOffset," | BEPoints : ",BEPoints," | TrailOffset : ", TrailOffset," | TrailPoints : ", TrailPoints);
	string Comment5=StringConcatenate("CTCBN : ",CTCBN," | SecBPO : ",SecBPO," | SecBAO : ",SecBAO," | SecBMO : ",SecBMO," | STWAN : ",STWAN," | OCO : ",DisplayOCO);
	string Comment6=StringConcatenate("Money Management : ",DisplayMM," | RiskPercent: ",RiskPercent," | Lots : ",LotsOptimized());
	string Comment7=StringConcatenate("AddSpreadToSL : ",DisplayAddSpreadToSL," | SlipCheck : ",DisplaySlipCheck," | TrailImmediate : ",DisplayTrailImmediate);
	string Comment8=StringConcatenate("MaxSlippage : ",MaxSlippage," | MaxSpread : ",MaxSpread," | Spread : ",spread);
	//	string Comment8=StringConcatenate("MaxSlippage : ",MaxSlippage," | MaxSpread : ",MaxSpread," | Spread : ",spread," | OrdersTriggered : ",DisplayOrdersTriggered);
	string Comment9=StringConcatenate("AllowBuys : ",DisplayAllowBuys," | AllowSells : ",DisplayAllowSells," | UseBrokerTime : ",DisplayUseBrokerTime);

	// TradeComment gets added in the Comment field of trades. Max 32 chars.
	// Pipe character denotes different section, helping to logically group parameters.
	if (PointsAway>=PointsGap) 
	{ 
		TradeComment=StringConcatenate("P", PointsAway-PointsGap, "T", TP, "S", SL, "C", CTCBN, "P", SecBPO, "A", SecBAO, "M", SecBMO, "W", STWAN, "O", OCO, "B", BEPoints, "T", TrailPoints);
	}
	else
	{
		TradeComment=StringConcatenate("P", PointsAway, "T", TP, "S", SL, "C", CTCBN, "P", SecBPO, "A", SecBAO, "M", SecBMO, "W", STWAN, "O", OCO, "B", BEPoints, "T", TrailPoints );
	}

	if (MaxSpread!=0)
	{
		if (spread>MaxSpread) {
			Write("MaxSpread Exceeded, MaxSpread: "+MaxSpread+" Spread : "+spread);
			OrdersDeleteAll();
			Comment("\n",title,"\n\n",timetitle,"\n\n","MaxSpread : ",MaxSpread," | Spread : ",spread,"\n\n","Expert is disabled because Spread exceeds MaxSpread Setting");
			// Despite the comment above, the expert is not really disabled, it just exits without trading.
			// The return statement below is very important as it ensures the EA exits without opening trades if the Spread is too high.
			Sleep(5000); // Suspend for 5 seconds
			return (0);
		}
	}

	if ((!UseBrokerTime && NYear==DYear && NMonth==DMonth && NDay==DDay) || (UseBrokerTime && NYear==Year() && NMonth==Month() && NDay==Day()) || (NYear==0 && NMonth==0 && NDay==0))
	{
		Comment("\n",title,"\n\n",timetitle,"\n\n",Comment1,"\n", Comment2,"\n\n", Comment3,"\n\n",Comment4,"\n\n",Comment5,"\n\n",Comment6,"\n\n",Comment7,"\n\n",Comment8,"\n\n",Comment9);
	}
	else
	{
		Comment("\n",title,"\n\n",timetitle,"\n\n","Expert is disabled because it is not day of expected news");
		// Despite the comment above, the expert is not really disabled, it just exits without trading.
		// The return statement below is very important as it ensures the EA exits without opening trades on non-news days. 
		return(0);
	} 

	// OrdersCondition Result Pattern
	//    1    1    1    1
	//    b    s    bs   ss
	//

	if (secofday<secofnews && secofday>(secofnews-SecBPO)) 
	//	if (secofday<secofnews && secofday>(secofnews-SecBPO) && !OrdersTriggered) 
	{ // if before news but after news minus BPO
		if (OrdersCondition==0) { // if we have no orders
			Write(title);
			if (AllowBuys) { // if buys are allowed
				Write("Opening BuyStop @ "+DoubleToStr(ho,Digits)+", OrdersCondition="+OrdersCondition);
				OpenBuyStop();
			}
			if (AllowSells) { // if sells are allowed
				Write("Opening SellStop @ "+DoubleToStr(lo,Digits)+", OrdersCondition="+OrdersCondition);
				OpenSellStop();
			}
		}
		if (OrdersCondition==1 && AllowBuys) { // if we only have a sell stop and buys are allowed
			Write("Opening BuyStop @ "+DoubleToStr(ho,Digits)+", OrdersCondition="+OrdersCondition);
			OpenBuyStop();
		}
		if (OrdersCondition==10 && AllowSells) { // if we only have a buy stop and sells are allowed
			Write("Opening SellStop @ "+DoubleToStr(lo,Digits)+", OrdersCondition="+OrdersCondition);
			OpenSellStop();
		}
	}

	if (secofday<(secofnews+STWAN) && secofday>(secofnews-SecBAO) && secofday<(secofnews-SecBMO)) 
	{ // if before STWAN but after news minus BAO and before news minus BMO (allows negative BMO)
		Write("Modifying Orders, OrdersCondition="+OrdersCondition);
		DoModify();
	}

	if (secofday>secofnews && secofday<(secofnews+STWAN) && OCO) 
	{ // if after news and within wait time and we are using one cancels other
		if (OrdersCondition==1001) { // if we have a buy and a sell stop
			Write("Deleting SellStop because BuyStop Hit, OrdersCondition="+OrdersCondition);
			DeleteSellStop();
		}
		if (OrdersCondition==110) { // if we have a sell and a buy stop
			Write("Deleting BuyStop because SellStop Hit, OrdersCondition="+OrdersCondition);
			DeleteBuyStop();
		}
	}

	if (secofday>secofnews && secofday>(secofnews+STWAN)) 
	{ // if after news and after wait time 
		if (OrdersCondition==11) { // if we have a buy stop and a sell stop
			Write("Deleting BuyStop and SellStop because STWAN expired, OrdersCondition="+OrdersCondition);
			DeleteSellStop();
			DeleteBuyStop();
		}
		if (OrdersCondition==1 || OrdersCondition==1001) { // if we have a sell stop or a buy and a sell stop
			Write("Deleting SellStop because STWAN expired, OrdersCondition="+OrdersCondition);
			DeleteSellStop();
		}
		if (OrdersCondition==10 || OrdersCondition==110) { // if we have a buy stop or a sell and a buy stop
			Write("Deleting BuyStop because STWAN expired, OrdersCondition="+OrdersCondition);
			DeleteBuyStop();
		}
	}

	//----
	return(0);
}

//+------------------------------------------------------------------+
//| return error description                                         |
//+------------------------------------------------------------------+
string ErrorDescription(int error_code)
{
	string error_string;
	//----
	switch(error_code)
	{
		//---- codes returned from trade server
	case 0:
	case 1:   error_string="No Error";                                                  break;
	case 2:   error_string="Common Error";                                              break;
	case 3:   error_string="Invalid Trade Parameters";                                  break;
	case 4:   error_string="Trade Server Is Busy";                                      break;
	case 5:   error_string="Old Version Of The Client Terminal";                        break;
	case 6:   error_string="No Connection With Trade Server";                           break;
	case 7:   error_string="Not Enough Rights";                                         break;
	case 8:   error_string="Too Frequent Requests";                                     break;
	case 9:   error_string="Malfunctional Trade Operation";                             break;
	case 64:  error_string="Account Disabled";                                          break;
	case 65:  error_string="Invalid Account";                                           break;
	case 128: error_string="Trade Timeout";                                             break;
	case 129: error_string="Invalid Price";                                             break;
	case 130: error_string="Invalid Stops";                                             break;
	case 131: error_string="Invalid Trade Volume";                                      break;
	case 132: error_string="Market Is Closed";                                          break;
	case 133: error_string="Trade Is Disabled";                                         break;
	case 134: error_string="Not Enough Money";                                          break;
	case 135: error_string="Price Changed";                                             break;
	case 136: error_string="Off Quotes";                                                break;
	case 137: error_string="Broker Is Busy";                                            break;
	case 138: error_string="Requote";                                                   break;
	case 139: error_string="Order Is Locked";                                           break;
	case 140: error_string="Long Positions Only Allowed";                               break;
	case 141: error_string="Too Many Requests";                                         break;
	case 145: error_string="Modification Denied Because Order Too Close To Market";     break;
	case 146: error_string="Trade Context Is Busy";                                     break;
	case 147: error_string="Expirations Are Denied By Broker";                          break;
	case 148: error_string="Amount Of Open And Pending Orders Broker Limit Exceeded";   break;
	case 149: error_string="Attempt To Open Opposite Position And Hedging Is Disabled"; break;
	case 150: error_string="Attempt To Close A Position Contravening The Fifo Rule";    break;
		//---- mql4 Errors
	case 4000: error_string="No Error";                                                 break;
	case 4001: error_string="Wrong Function Pointer";                                   break;
	case 4002: error_string="Array Index Is Out Of Range";                              break;
	case 4003: error_string="No Memory For Function Call Stack";                        break;
	case 4004: error_string="Recursive Stack Overflow";                                 break;
	case 4005: error_string="Not Enough Stack For Parameter";                           break;
	case 4006: error_string="No Memory For Parameter String";                           break;
	case 4007: error_string="No Memory For Temp String";                                break;
	case 4008: error_string="Not Initialized String";                                   break;
	case 4009: error_string="Not Initialized String In Array";                          break;
	case 4010: error_string="No Memory For Array\' String";                             break;
	case 4011: error_string="Too Long String";                                          break;
	case 4012: error_string="Remainder From Zero Divide";                               break;
	case 4013: error_string="Zero Divide";                                              break;
	case 4014: error_string="Unknown Command";                                          break;
	case 4015: error_string="Wrong Jump (Never Generated Error)";                       break;
	case 4016: error_string="Not Initialized Array";                                    break;
	case 4017: error_string="Dll Calls Are Not Allowed";                                break;
	case 4018: error_string="Cannot Load Library";                                      break;
	case 4019: error_string="Cannot Call Function";                                     break;
	case 4020: error_string="Expert Function Calls Are Not Allowed";                    break;
	case 4021: error_string="Not Enough Memory For Temp String Returned From Function"; break;
	case 4022: error_string="System Is Busy (Never Generated Error)";                   break;
	case 4050: error_string="Invalid Function Parameters Count";                        break;
	case 4051: error_string="Invalid Function Parameter Value";                         break;
	case 4052: error_string="String Function Internal Error";                           break;
	case 4053: error_string="Some Array Error";                                         break;
	case 4054: error_string="Incorrect Series Array Using";                             break;
	case 4055: error_string="Custom Indicator Error";                                   break;
	case 4056: error_string="Arrays Are Incompatible";                                  break;
	case 4057: error_string="Global Variables Processing Error";                        break;
	case 4058: error_string="Global Variable Not Found";                                break;
	case 4059: error_string="Function Is Not Allowed In Testing Mode";                  break;
	case 4060: error_string="Function Is Not Confirmed";                                break;
	case 4061: error_string="Send Mail Error";                                          break;
	case 4062: error_string="String Parameter Expected";                                break;
	case 4063: error_string="Integer Parameter Expected";                               break;
	case 4064: error_string="Double Parameter Expected";                                break;
	case 4065: error_string="Array As Parameter Expected";                              break;
	case 4066: error_string="Requested History Data In Update State";                   break;
	case 4067: error_string="Some Error In Trading Function";                           break;
	case 4099: error_string="End Of File";                                              break;
	case 4100: error_string="Some File Error";                                          break;
	case 4101: error_string="Wrong File Name";                                          break;
	case 4102: error_string="Too Many Opened Files";                                    break;
	case 4103: error_string="Cannot Open File";                                         break;
	case 4104: error_string="Incompatible Access To A File";                            break;
	case 4105: error_string="No Order Selected";                                        break;
	case 4106: error_string="Unknown Symbol";                                           break;
	case 4107: error_string="Invalid Price Parameter For Trade Function";               break;
	case 4108: error_string="Invalid Ticket";                                           break;
	case 4109: error_string="Trade Is Not Allowed";                                     break;
	case 4110: error_string="Longs Are Not Allowed";                                    break;
	case 4111: error_string="Shorts Are Not Allowed";                                   break;
	case 4200: error_string="Object Is Already Exist";                                  break;
	case 4201: error_string="Unknown Object Property";                                  break;
	case 4202: error_string="Object Is Not Exist";                                      break;
	case 4203: error_string="Unknown Object Type";                                      break;
	case 4204: error_string="No Object Name";                                           break;
	case 4205: error_string="Object Coordinates Error";                                 break;
	case 4206: error_string="No Specified Subwindow";                                   break;
	case 4207: error_string="Some Error In Object Function";                            break;
	default:   error_string="Unknown Error";
	}
	//----
	return(error_string);
}  
//+------------------------------------------------------------------+